<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

require_once(JPATH_COMPONENT_SITE . "/libs/dompdf/autoload.inc.php");

use Dompdf\Dompdf;

class RedstampControllerBolle extends JControllerLegacy {

    public function getModel($name = '', $prefix = '', $config = array('ignore_request' => true)) {
        return parent::getModel($name, $prefix, $config);
    }

    public function save() {
        $input = JRequest::get('post');
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select("*")
                ->from("#__redstamp_anagrafiche")
                ->where("idAnagrafica = " . $input['idAnagrafica']);
        $db->setQuery($query);
        $anagrafica = $db->loadObject();

        if ($input['indirizzoSpedizione']) {
            $query = $db->getQuery(true);
            $query->select("*")
                    ->from("#__redstamp_indirizzi")
                    ->where("idINdirizzo = " . $input['indirizzoSpedizione']);
            $db->setQuery($query);
            $indirizzoSpedizione = $db->loadObject();

            $input['adindirizzo'] = $indirizzoSpedizione->indirizzo;
            $input['adcomune'] = $indirizzoSpedizione->comune;
            $input['adprovincia'] = $indirizzoSpedizione->provincia;
            $input['adcap'] = $indirizzoSpedizione->cap;
            $input['adRagioneSociale'] = $indirizzoSpedizione->ragioneSociale;
        } else {
            $input['adRagioneSociale'] = $anagrafica->ragioneSociale;
            $input['adindirizzo'] = $input['indirizzo'];
            $input['adcomune'] = $input['comune'];
            $input['adprovincia'] = $input['provincia'];
            $input['adcap'] = $input['cap'];
        }


        $data = new stdClass();
        $data->idAnagrafica = $input['idAnagrafica'];
        $data->indirizzo = $input['indirizzo'];
        $data->comune = $input['comune'];
        $data->provincia = $input['provincia'];
        $data->cap = $input['cap'];
        $data->note = $input['note'];
        $data->volume = $input['volume'];
        $data->peso = $input['peso'];
        $data->colli = $input['colli'];
        $data->causale = $input['causale'];
        $data->trasporto = $input['trasporto'];
        $data->vettore = $input['vettore'];
        $data->dataRitiro = $input['dataRitiro'];
        $data->ragioneSociale = $anagrafica->ragioneSociale;
        $data->pIVA = $anagrafica->pIVA;
        $data->codiceFiscale = $anagrafica->codiceFiscale;
        $data->adRagioneSociale = $input['adRagioneSociale'];
        $data->adIndirizzo = $input['adindirizzo'];
        $data->adComune = $input['adcomune'];
        $data->adCap = $input['adcap'];
        $data->adProvincia = $input['adprovincia'];
        $data->idIndrizzoSpedizione = $input['indirizzoSpedizione'];
        $data->aspettoBeni = $input['aspettoBeni'];
        list($d, $m, $y) = explode("/", $data->dataRitiro);
        $data->dataRitiro = "{$y}-{$m}-{$d} 12:00:00";

        $prodotti = array();
        if ($input['prodotto'] && $input['costo'] && $input['quantita']) {
            foreach ($input['prodotto'] as $k => $prodotto) {
                if ($prodotto) {
                    $prodotti[] = array(
                        'prodotto' => $prodotto,
                        'costo' => $input['costo'][$k],
                        'quantita' => $input['quantita'][$k]
                    );
                }
            }
        }
        $data->prodotti = serialize($prodotti);

        if ($input['idBolla']) {
            $data->idBolla = $input['idBolla'];
            $db->updateObject('#__redstamp_bolle', $data, 'idBolla');
        } else {

            $query = $db->getQuery(true);
            $query->select("COUNT(*)")->from("#__redstamp_bolle")->where("YEAR(inserted) = YEAR(NOW())");

            $db->setQuery($query);
            $count = $db->loadResult();
            if (date("Y") == '2017') {
                $count += 110;
            }
            $count += 1;
            $data->progressivo = str_pad($count, 4, "0", STR_PAD_LEFT) . "/A" . date("Y");
            $db->insertObject('#__redstamp_bolle', $data, 'idBolla');
        }

        JFactory::getApplication()->enqueueMessage(JText::_('COM_REDSTAMP_BOLLA_OK'), 'success');
        echo new JResponseJson(array("status" => true, "script" => "window.location.reload();"));
        JFactory::getApplication()->close();
    }

    public function remove() {
        $input = JRequest::getVar('idBolla');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $conditions = array(
            $db->quoteName('idBolla') . ' = ' . $db->quote($input)
        );

        $query->delete($db->quoteName('#__redstamp_bolle'));
        $query->where($conditions);

        $db->setQuery($query);

        if ($db->execute()) {
            JFactory::getApplication()->enqueueMessage(JText::_('COM_REDSTAMP_DELBOLLA_OK'), 'success');
            echo new JResponseJson(array("status" => true));
        } else {
            JFactory::getApplication()->enqueueMessage(JText::_('COM_REDSTAMP_DELBOLLA_KO'), 'error');
            echo new JResponseJson(array("status" => false));
        }
        JFactory::getApplication()->close();
    }

    public function export() {
        if (!JRequest::getVar("idBolla")) {
            JError::raiseError(500, JText::_("idBolla is missing"));
            return false;
        }
        $dompdf = new Dompdf();

        $bolla = $this->getModel("Bolle")->getBolla(JRequest::getVar("idBolla"));

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf-bolla.php");
        $result = ob_get_clean();

        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream(JFilterOutput::stringURLSafe("DDT " . $bolla->progressivo));
        exit;
    }

    public function getIndirizzi() {
        if (!JRequest::getVar("idAnagrafica")) {
            JError::raiseError(500, JText::_("adAnagrafica is missing"));
            return false;
        }

        echo $indirizzi = $this->getModel("Bolle")->getIndirizzi(JRequest::getVar("idAnagrafica"));

        JFactory::getApplication()->close();
    }

    public function send_mail() {
        if (!JRequest::getVar("idBolla")) {
            JError::raiseError(500, JText::_("idBolla is missing"));
            return false;
        }

        $bolla = $this->getModel("Bolle")->getBolla(JRequest::getVar("idBolla"));

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf-bolla.php");
        $result = ob_get_clean();

        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $output = $dompdf->output();

        if (!is_dir(JPATH_COMPONENT_SITE . "/temp/")) {
            mkdir(JPATH_COMPONENT_SITE . "/temp/");
        }

        $filename = JFilterOutput::stringURLSafe("ddt-" . $bolla->progressivo) . ".pdf";

        file_put_contents(JPATH_COMPONENT_SITE . "/temp/" . $filename, $output);

        $mailer = JFactory::getMailer();

        $config = JFactory::getConfig();
        $sender = array(
            $config->get('mailfrom'),
            $config->get('fromname')
        );

        $mailer->setSender($sender);

        if (defined('REDSTAMP_DEBUG') && REDSTAMP_DEBUG) {
            $mailer->addRecipient(DEBUG_EMAIL);
        } else {
            $mailer->addRecipient($bolla->Amail);
        }

        ob_start();
        ?>
        Buongiorno,<br><br>
        inviamo DDT nr. <?php echo $bolla->progressivo ?> del <?php echo date("d/m/Y", strtotime($bolla->inserted)) ?>.<br><br>
        Cordiali saluti<br><br>
        <b>Amministrazione</b><br><br>
        <?php echo $config->get('fromname') ?><br><br>
        <img src="<?php echo JURI::root() ?>/images/logo.png" style="max-width: 175px;"/>
        <?php
        $html = ob_get_clean();

        $mailer->setSubject('DDT ' . $bolla->progressivo . ' del ' . date("d/m/Y", strtotime($bolla->inserted)));
        $mailer->isHtml(true);
        $mailer->Encoding = 'base64';
        $mailer->setBody($html);

        $mailer->addAttachment(JPATH_COMPONENT_SITE . "/temp/" . $filename);

        if ($mailer->Send() !== true) {
            echo new JResponseJson(array("status" => true, "message" => "<h2 class='text-danger'>ATTENZIONE<h2>Problemi nell'invio mail"));
        } else {
            echo new JResponseJson(array("status" => true, "message" => "Mail inviata con successo."));
        }
        unlink(JPATH_COMPONENT_SITE . "/temp/" . $filename);

        JFactory::getApplication()->close();
    }

}
