<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

require_once(JPATH_COMPONENT_SITE . "/libs/dompdf/autoload.inc.php");

use Dompdf\Dompdf;

class RedstampControllerFatture extends JControllerLegacy {

    public function getModel($name = '', $prefix = '', $config = array('ignore_request' => true)) {
        return parent::getModel($name, $prefix, $config);
    }

    public function save() {
        $input = JRequest::get('post');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select("*")
                ->from("#__redstamp_anagrafiche")
                ->where("idAnagrafica = " . $input['idAnagrafica']);
        $db->setQuery($query);
        $anagrafica = $db->loadObject();

        if (!$input['idFattura']) {
            $query->clear();
            $query->select("MAX(nFattura)")
                    ->from("#__redstamp_fatture");
            $db->setQuery($query);
            $nFattura = $db->loadResult();

            if (!$nFattura || $nFattura == 0) {
                $nFattura = 787;
            } else {
                $nFattura = (int) $nFattura + 1;
            }
        }

        $data = new stdClass();
        $data->idAnagrafica = $input['idAnagrafica'];
        $data->note = $input['note'];
        $data->volume = $input['volume'];
        $data->peso = $input['peso'];
        $data->colli = $input['colli'];
        $data->causale = $input['causale'];
        $data->trasporto = $input['trasporto'];
        $data->vettore = $input['vettore'];
        $data->dataRitiro = $input['dataRitiro'];
        $data->pagamento = $input['pagamento'];
        $data->ragioneSociale = $anagrafica->ragioneSociale;
        $data->indirizzo = $anagrafica->indirizzo;
        $data->comune = $anagrafica->comune;
        $data->provincia = $anagrafica->provincia;
        $data->pIVA = $anagrafica->pIVA;
        $data->iva = $anagrafica->iva;
        $data->nFattura = $nFattura;
        $data->dataFattura = date("Y-m-d", strtotime(str_replace("/", "-", $input['dataFattura'])));
        $data->codiceFiscale = $anagrafica->codiceFiscale;
        list($d, $m, $y) = explode("/", $data->dataRitiro);
        $data->dataRitiro = "{$y}-{$m}-{$d} 12:00:00";

        $prodotti = array();

        foreach ($input['prodotto'] as $bolla => $prodotti2) {

            foreach ($prodotti2 as $k => $prodotto) {
                if ($prodotto) {

                    $prodotti[$bolla][] = array(
                        'prodotto' => $prodotto,
                        'costo' => $input['costo'][$bolla][$k],
                        'quantita' => $input['quantita'][$bolla][$k]
                    );
                }
            }
        }

        $data->prodotti = serialize($prodotti);

        if ($input['idFattura']) {
            $data->idFattura = $input['idFattura'];
            $db->updateObject('#__redstamp_fatture', $data, 'idFattura');
        } else {
            $db->insertObject('#__redstamp_fatture', $data, 'idFattura');
        }

        JFactory::getApplication()->enqueueMessage(JText::_('COM_REDSTAMP_FATTURA_OK'), 'success');
        echo new JResponseJson(array("status" => true, "script" => "window.location.reload();"));
        JFactory::getApplication()->close();
    }

    public function remove() {
        $input = JRequest::getVar('idFattura');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $conditions = array(
            $db->quoteName('idFattura') . ' = ' . $db->quote($input)
        );

        $query->delete($db->quoteName('#__redstamp_fatture'));
        $query->where($conditions);

        $db->setQuery($query);
        $db->execute();

        $query->clear();
        $query->update('#__redstamp_bolle');
        $query->set('idFattura = 0');
        $query->where('idFattura=' . $input);
        $db->setQuery($query);

        if ($db->execute()) {
            JFactory::getApplication()->enqueueMessage(JText::_('COM_REDSTAMP_DELFATTURA_OK'), 'success');
            echo new JResponseJson(array("status" => true));
        } else {
            JFactory::getApplication()->enqueueMessage(JText::_('COM_REDSTAMP_DELFATTURA_KO'), 'error');
            echo new JResponseJson(array("status" => false));
        }
        JFactory::getApplication()->close();
    }

    public function generate() {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        if (JRequest::getVar("idBolla")) {
            $idBolla = JRequest::getVar("idBolla");
            $idBolle = explode(",", $idBolla);

            foreach ($idBolle as $bolla) {

                $query->clear();
                $query->select("idFattura")
                        ->from("#__redstamp_bolle")
                        ->where("idBolla = {$bolla}");
                $db->setQuery($query);
                $fatturaEsistente = $db->loadResult();
                if ($fatturaEsistente) {

                    echo new JResponseJson(array("status" => true, "idFattura" => $fatturaEsistente));
                    exit;
                }
            }
            $query->clear();
            $query->select("idAnagrafica")
                    ->from("#__redstamp_bolle")
                    ->where("idBolla = {$idBolle[0]}");
            $db->setQuery($query);
            $idAnagrafica = $db->loadResult();

            $query->clear();
            $query->select("*")
                    ->from("#__redstamp_anagrafiche")
                    ->where("idAnagrafica = " . $idAnagrafica);
            $db->setQuery($query);
            $anagrafica = $db->loadObject();

            $bolle = $this->getBolla($idBolla);

//            $conditions = array(
//                $db->quoteName('idBolla') . ' = ' . $db->quote(JRequest::getVar("idBolla"))
//            );
//            $query->clear()
//                    ->delete($db->quoteName('#__redstamp_fatture'))
//                    ->where($conditions);
//
//            $db->setQuery($query);
//            $db->execute();

            foreach ($bolle as $bolla) {
                $prodBolle[$bolla->idBolla] = $bolla->prodotti;
            }

            $query->clear();
            $query->select("MAX(nFattura)")
                    ->from("#__redstamp_fatture");
            $db->setQuery($query);
            $nFattura = $db->loadResult();

            if (!$nFattura || $nFattura == 0) {
                $nFattura = 787;
            } else {
                $nFattura = (int) $nFattura + 1;
            }

            $obj = new stdClass();
//            $obj->idBolla = $bolle->idBolla;
            $obj->idAnagrafica = $idAnagrafica;
            $obj->ragioneSociale = $anagrafica->ragioneSociale;
            $obj->indirizzo = $anagrafica->indirizzo;
            $obj->comune = $anagrafica->comune;
            $obj->provincia = $anagrafica->provincia;
            $obj->pIVA = $anagrafica->pIVA;
            $obj->iva = $anagrafica->iva;
            $obj->codiceFiscale = $anagrafica->codiceFiscale;
            $obj->nFattura = $nFattura;
            $obj->prodotti = serialize($prodBolle);

            if ($db->insertObject('#__redstamp_fatture', $obj, 'idFattura')) {
                $id = $db->insertid();

                foreach ($bolle as $bolla) {
                    $obj = new stdClass();
                    $obj->idBolla = $bolla->idBolla;
                    $obj->idFattura = $id;
                    $db->updateObject('#__redstamp_bolle', $obj, 'idBolla');
                }
                echo new JResponseJson(array("status" => true, "idFattura" => $id));
                exit;
            }
        }
        echo new JResponseJson(array("status" => false));
        exit;
    }

    function getBolla($idBolle) {

        $idBolle = explode(",", $idBolle);


        $db = JFactory::getDBO();
        $query = $db->getQuery(true);


        foreach ($idBolle as $idBolla) {
            $query->clear();
            $query->select("*")
                    ->from("#__redstamp_bolle")
                    ->where("idBolla = {$idBolla}");
            $db->setQuery($query);
            $datiBolle[$idBolla] = $db->loadObject();
            $datiBolle[$idBolla]->prodotti = unserialize($datiBolle[$idBolla]->prodotti);
        }


        return $datiBolle;
    }

    public function export() {
        if (!JRequest::getVar("idFattura")) {
            JError::raiseError(500, JText::_("idFattura is missing"));
            return false;
        }
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $fattura = $this->getModel("Fatture")->getFattura(JRequest::getVar("idFattura"));

        if ($fattura->pagamento > 1) {
            $query->clear();
            $query->select("*")
                    ->from("#__redstamp_datibancari")
                    ->where("idAnagrafica = {$fattura->idAnagrafica}");
            $db->setQuery($query);
            $databancari = $db->loadObject();
        }

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf-fattura.php");

        $result = ob_get_clean();

        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream(JFilterOutput::stringURLSafe("fattura " . $fattura->nFattura));
        exit;
    }

    public function send_mail() {
        if (!JRequest::getVar("idFattura")) {
            JError::raiseError(500, JText::_("idBolla is missing"));
            return false;
        }

        $fattura = $this->getModel("Fatture")->getFattura(JRequest::getVar("idFattura"));

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf-fattura.php");
        $result = ob_get_clean();

        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $output = $dompdf->output();

        if (!is_dir(JPATH_COMPONENT_SITE . "/temp/")) {
            mkdir(JPATH_COMPONENT_SITE . "/temp/");
        }

        $filename = JFilterOutput::stringURLSafe("fattura-" . $fattura->nFattura) . ".pdf";

        file_put_contents(JPATH_COMPONENT_SITE . "/temp/" . $filename, $output);

        $mailer = JFactory::getMailer();

        $config = JFactory::getConfig();
        $sender = array(
            $config->get('mailfrom'),
            $config->get('fromname')
        );

        $mailer->setSender($sender);

        if (defined('REDSTAMP_DEBUG') && REDSTAMP_DEBUG) {
            $mailer->addRecipient(DEBUG_EMAIL);
        } else {
            $mailer->addRecipient($fattura->Amail);
        }

        ob_start();
        ?>
        Buongiorno,<br><br>
        inviamo fattura nr. <?php echo $fattura->nFattura ?> del <?php echo date("d/m/Y", strtotime($fattura->dataFattura)) ?><br><br>
        Cordiali saluti<br><br>
        
        <b>Amministrazione</b><br><br>
        <?php echo $config->get('fromname') ?><br><br>
        <img src="<?php echo JURI::root() ?>/images/logo.png" style="max-width: 175px;"/>
        <?php
        $html = ob_get_clean();

        $mailer->setSubject('Fattura ' . $fattura->nFattura . ' del ' . date("d/m/Y", strtotime($fattura->dataFattura)));
        $mailer->isHtml(true);
        $mailer->Encoding = 'base64';
        $mailer->setBody($html);

        $mailer->addAttachment(JPATH_COMPONENT_SITE . "/temp/" . $filename);

        if ($mailer->Send() !== true) {
            echo new JResponseJson(array("status" => true, "message" => "<h2 class='text-danger'>ATTENZIONE<h2>Problemi nell'invio mail"));
        } else {
            echo new JResponseJson(array("status" => true, "message" => "Mail inviata con successo."));
        }
        unlink(JPATH_COMPONENT_SITE . "/temp/" . $filename);

        JFactory::getApplication()->close();
    }

}
