<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class RedstampModelBolle extends JModelList {

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');

        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));
        $query->select("b.*, a.email")
                ->from("#__redstamp_bolle b")
                ->innerJoin("#__redstamp_anagrafiche a ON a.idAnagrafica = b.idAnagrafica")
                //->leftJoin("#__redstamp_fatture f ON f.idBolla = b.idBolla")
                ->order("idBolla DESC")
                ->limit($this->limitstart . ", " . $this->limit);

        if ($search) {
            
        }
        
        return $query;
    }

    function getBolla($idbolla) {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("b.*, a.ragioneSociale, a.indirizzo as Aindirizzo, a.comune as Acomune, a.provincia as Aprovincia, a.email as Amail, a.pIVA as ApIVA")
                ->from("#__redstamp_bolle b")
                ->innerJoin("#__redstamp_anagrafiche a ON a.idAnagrafica = b.idAnagrafica")
                ->where("idBolla = {$idbolla}");
        $db->setQuery($query);

        $array = $db->loadObject();
        $array->prodotti = unserialize($array->prodotti);
        
        $query->clear();
        $query->select("*")
                ->from("#__redstamp_indirizzi")
                ->where("idAnagrafica = {$array->idAnagrafica}");
        $db->setQuery($query);

        $array->indirizzi = $db->loadObjectList();

        return $array;
    }
    
    function getIndirizzi($idAnagrafica) {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("*")
                ->from("#__redstamp_indirizzi b")
                ->where("idAnagrafica = {$idAnagrafica}");
        $db->setQuery($query);

        $indirizzi = $db->loadObjectList();
        
        
        require_once (JPATH_COMPONENT_SITE . "/templates/indirizzi.php");

        
    }
    
    

}
